function [sys, x0, str, ts] = filtre4(t,X,u,flag)
%
% Lancer dVsurdT au pralable (pour initialiser les entres).
% Cette version est un modle polynomiale discontinu en 0.
%
global n N d A C Q R1 P X0 eta epsilon
if abs(flag)==1 % Drives    
    P=SymReshape(X((n+1):end));
    v=X(1);
    w=X(2);
%    phi=X(3:n);
    vmes=u(1);
    wmes=u(2);
    vdot=v-v^3/3-w;

    if vmes<=0,
        phi=X(3);
    else,
        phi=X(4);
    end,
%     alpha=0.5;
%     beta=1.96;
%     gV=(alpha*(v<=0)+beta*(v>0));

    wdot=epsilon*(phi*v-w-eta);
    Xdot=[vdot;wdot;X(5:8);zeros(2,1)];
    Xdot=( Xdot+P*C'*R1*[vmes-v;wmes-w] );
    A=zeros(n,n);
    A(1,1)=1-v^2;
    A(1,2)=-1;
    A(2,1)=epsilon*phi;
    A(2,2)=-epsilon;
    if vmes<-0.1,
        A(2,3)=epsilon*v;
        A(2,4)=0;
    elseif vmes>0.1,
        A(2,3)=0;
        A(2,4)=epsilon*v;
    else,
        A(2,3)=0;
        A(2,4)=0;
    end,
    A(3:4,5:6)=eye(2);
    A(5:6,7:8)=eye(2);    
    Pdot=( A*P+P*A'+Q-P*C'*R1*C*P );
    sys = [Xdot;SymReshape(Pdot)];
elseif flag==0 % Initialisation
    N=2*3;               % ordre du modle polynomial
    n=2+N;               % dimension de l'espace d'tat
    d=n+n*(n+1)/2;       % dimension de l'tat du filtre
    sizes = simsizes;
    sizes.NumContStates  = d;
    sizes.NumDiscStates  = 0;
    sizes.NumOutputs     = 5;
    sizes.NumInputs      = 2;
    sizes.DirFeedthrough = 0;
    sizes.NumSampleTimes = 0;
    sys = simsizes(sizes);
    X0=[0;0;1;1;0;0;0;0];
    P0=zeros(n,n);
    x0=[X0(:);SymReshape(P0)];
    str=[];
    ts=[];
    C=[eye(2),zeros(2,N)];
    Q=diag([1,1,0.1,0.1,0.01,0.01,0.001,0.001]);
%     theta=5;
%     for i=3:n,
%         Q(i,i)=theta*Q(i,i);
%     end,
    R=1e5*eye(2);
    R1=inv(R);
    gamma=1.138;
    R0=1023;
    R6=2021;
    CC=1.426e-9;
    E1=356.41e-3;
    E2=-622.6e-3;
    L1=9.94e-3;
    L2=3.43e-3;
    eta=gamma*R0*E1/R6
    epsilon=R0*R6*CC/L1    
elseif flag==3 % sorties
    sys=[X(1:4);0];
    if X(1)<=0,
        sys(5)=X(1)*X(3);
    else,
        sys(5)=X(1)*X(4);
    end,
end
